require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PARAM_H)) {
    eval 'sub _SYS_PARAM_H () {1;}' unless defined(&_SYS_PARAM_H);
    require 'limits.ph';
    require 'sys/syslimits.ph';
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    require 'osreldate.ph';
    require 'sys/types.ph';
    require 'stdint.ph';
    eval 'sub MAXCOMLEN () {19;}' unless defined(&MAXCOMLEN);
    eval 'sub MAXINTERP () {32;}' unless defined(&MAXINTERP);
    eval 'sub MAXLOGNAME () {17;}' unless defined(&MAXLOGNAME);
    eval 'sub MAXUPRC () { &CHILD_MAX;}' unless defined(&MAXUPRC);
    eval 'sub NCARGS () { &ARG_MAX;}' unless defined(&NCARGS);
    eval 'sub NGROUPS () { &NGROUPS_MAX;}' unless defined(&NGROUPS);
    eval 'sub NOGROUP () {65535;}' unless defined(&NOGROUP);
    eval 'sub MAXHOSTNAMELEN () {256;}' unless defined(&MAXHOSTNAMELEN);
    eval 'sub SPECNAMELEN () {63;}' unless defined(&SPECNAMELEN);
    eval 'sub TTY_NAME_MAX () { &SPECNAMELEN;}' unless defined(&TTY_NAME_MAX);
    eval 'sub NBBY () { &CHAR_BIT;}' unless defined(&NBBY);
    unless(defined(&NGROUPS)) {
	eval 'sub NGROUPS () { &NGROUPS_MAX;}' unless defined(&NGROUPS);
    }
    eval 'sub MAXSYMLINKS () {32;}' unless defined(&MAXSYMLINKS);
    eval 'sub CANBSIZ () { &MAX_CANON;}' unless defined(&CANBSIZ);
    eval 'sub NCARGS () { &ARG_MAX;}' unless defined(&NCARGS);
    eval 'sub MAXPATHLEN () { &PATH_MAX;}' unless defined(&MAXPATHLEN);
    eval 'sub NOFILE () { &OPEN_MAX;}' unless defined(&NOFILE);
    eval 'sub setbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] |= 1<<(($i)% &NBBY)));
    }' unless defined(&setbit);
    eval 'sub clrbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] &= ~(1<<(($i)% &NBBY))));
    }' unless defined(&clrbit);
    eval 'sub isset {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))));
    }' unless defined(&isset);
    eval 'sub isclr {
        my($a,$i) = @_;
	    eval q(((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))) == 0));
    }' unless defined(&isclr);
    unless(defined(&howmany)) {
	eval 'sub howmany {
	    my($x, $y) = @_;
    	    eval q(((($x) + (($y) - 1)) / ($y)));
	}' unless defined(&howmany);
    }
    if(defined(&__GNUC__)) {
	eval 'sub roundup {
	    my($x, $y) = @_;
    	    eval q(( &__builtin_constant_p ($y)  &&  &powerof2 ($y) ? ((($x) + ($y) - 1) & ~(($y) - 1)) : (((($x) + (($y) - 1)) / ($y)) * ($y))));
	}' unless defined(&roundup);
    } else {
	eval 'sub roundup {
	    my($x, $y) = @_;
    	    eval q((((($x) + (($y) - 1)) / ($y)) * ($y)));
	}' unless defined(&roundup);
    }
    eval 'sub powerof2 {
        my($x) = @_;
	    eval q((((($x) - 1) & ($x)) == 0));
    }' unless defined(&powerof2);
    eval 'sub MIN {
        my($a,$b) = @_;
	    eval q(((($a)<($b))?($a):($b)));
    }' unless defined(&MIN);
    eval 'sub MAX {
        my($a,$b) = @_;
	    eval q(((($a)>($b))?($a):($b)));
    }' unless defined(&MAX);
    require 'machine/param.ph';
    unless(defined(&DEV_BSHIFT)) {
	eval 'sub DEV_BSHIFT () {9;}' unless defined(&DEV_BSHIFT);
    }
    eval 'sub DEV_BSIZE () {(1<< &DEV_BSHIFT);}' unless defined(&DEV_BSIZE);
    unless(defined(&BLKDEV_IOSIZE)) {
	eval 'sub BLKDEV_IOSIZE () { &PAGE_SIZE;}' unless defined(&BLKDEV_IOSIZE);
    }
    unless(defined(&DFLTPHYS)) {
	eval 'sub DFLTPHYS () {(64* 1024);}' unless defined(&DFLTPHYS);
    }
    unless(defined(&MAXPHYS)) {
	eval 'sub MAXPHYS () {(128* 1024);}' unless defined(&MAXPHYS);
    }
    unless(defined(&MAXDUMPPGS)) {
	eval 'sub MAXDUMPPGS () {( &DFLTPHYS/ &PAGE_SIZE);}' unless defined(&MAXDUMPPGS);
	unless(defined(&MAXHOSTNAMELEN)) {
	    eval 'sub MAXHOSTNAMELEN () {64;}' unless defined(&MAXHOSTNAMELEN);
	}
	unless(defined(&MSIZE)) {
	    eval 'sub MSIZE () {256;}' unless defined(&MSIZE);
	}
	unless(defined(&MCLSHIFT)) {
	    eval 'sub MCLSHIFT () {11;}' unless defined(&MCLSHIFT);
	}
	eval 'sub MCLBYTES () {(1<<  &MCLSHIFT);}' unless defined(&MCLBYTES);
	unless(defined(&ctob)) {
	    eval 'sub ctob {
	        my($x) = @_;
    		eval q((($x)<< &PAGE_SHIFT));
	    }' unless defined(&ctob);
	}
	unless(defined(&btoc)) {
	    eval 'sub btoc {
	        my($x) = @_;
    		eval q(((( &vm_offset_t)($x)+ &PAGE_MASK)>> &PAGE_SHIFT));
	    }' unless defined(&btoc);
	}
	unless(defined(&btodb)) {
	    eval 'sub btodb {
	        my($bytes) = @_;
    		eval q(($sizeof{$bytes} > $sizeof{\'long\'} ? ( &daddr_t)(($bytes) >>  &DEV_BSHIFT) : ( &daddr_t)(($bytes) >>  &DEV_BSHIFT)));
	    }' unless defined(&btodb);
	}
	unless(defined(&dbtob)) {
	    eval 'sub dbtob {
	        my($db) = @_;
    		eval q((( &off_t)($db) <<  &DEV_BSHIFT));
	    }' unless defined(&dbtob);
	}
    }
    eval 'sub PRIMASK () {0xff;}' unless defined(&PRIMASK);
    eval 'sub PCATCH () {0x100;}' unless defined(&PCATCH);
    eval 'sub PDROP () {0x200;}' unless defined(&PDROP);
    eval 'sub NBPW () {$sizeof{\'int\'};}' unless defined(&NBPW);
    eval 'sub CMASK () {022;}' unless defined(&CMASK);
    eval 'sub NODEV () {( &dev_t)(-1);}' unless defined(&NODEV);
    eval 'sub CBLOCK () {128;}' unless defined(&CBLOCK);
    eval 'sub CBQSIZE () {( &CBLOCK/ &NBBY);}' unless defined(&CBQSIZE);
    eval 'sub CBSIZE () {( &CBLOCK - $sizeof{\'struct cblock\' } -  &CBQSIZE);}' unless defined(&CBSIZE);
    eval 'sub CROUND () {( &CBLOCK - 1);}' unless defined(&CROUND);
    eval 'sub MAXBSIZE () {65536;}' unless defined(&MAXBSIZE);
    eval 'sub BKVASIZE () {16384;}' unless defined(&BKVASIZE);
    eval 'sub BKVAMASK () {( &BKVASIZE-1);}' unless defined(&BKVAMASK);
    eval 'sub FSHIFT () {11;}' unless defined(&FSHIFT);
    eval 'sub FSCALE () {(1<< &FSHIFT);}' unless defined(&FSCALE);
    eval 'sub dbtoc {
        my($db) = @_;
	    eval q((($db + ( &ctodb(1) - 1)) >> ( &PAGE_SHIFT -  &DEV_BSHIFT)));
    }' unless defined(&dbtoc);
    eval 'sub ctodb {
        my($db) = @_;
	    eval q((($db) << ( &PAGE_SHIFT -  &DEV_BSHIFT)));
    }' unless defined(&ctodb);
}
1;
